#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
#include "labyrinth.h"
#include "textures.h"
#include "maps.h"

extern ball b;

int map[BOARD_WIDTH + 1][BOARD_WIDTH + 1]; /* array that will hold the map, map[z][x] */

/**
 * Loads an ascii map, and populate the map array
 */
int loadMap(char *file)
{
	char *c;
	int z,x,i,ball = 0;
	FILE *fp = fopen(file,"r");
	if(!fp){
		return 0;
	}

	c = (char*)malloc(1);

	for(z = 0;z <= BOARD_WIDTH;z++){
		for(x = 0;x <= BOARD_WIDTH;x++){
			fread(c,1,1,fp);
			i = atoi(c);
			map[z][x] = i;
			if(i == 3){
				if(ball == 0){
					/*
						set the initial starting point of the ball
						-10 because x and y starts a 0 in the loops
						above, while the coordinate system has 0 in
						the middle
					*/
					b.x = (x - 10) * SQUARE_SIZE + (SQUARE_SIZE / 2);
					b.z = (z - 10) * SQUARE_SIZE + (SQUARE_SIZE / 2);
					ball = 1;
				} else{
					map[z][x] = 1;
				}
			}
		}
	}

	free(c);

	fclose(fp);
	if(!ball){
		printf("The map does not contain a position for the ball (3).\n");
		exit(0);
	}

	return 1;
}
